Mon Apr 14 11:59:42 CEST 2003 hannes:
Summary of changes:
* help system configurable via LIB/help.cnf
* extension of ring concept: 
   new coefficient domains: arbitrary long real and complex numbers 
   no restriction on number of parameters 
   degree bound on exponent values (maximum is now 2^31, standard 2^15) 
   non-positives weights get a better handling (converts wp/Wp to ws/Ws) 
   handle blocks of mixed orders correctly 
   maximal prime characteristic is now 2147483629 instead of 32003 
* NTL integrated
* port to new, not compatible software (bison, readline, gcc3)

Fri Jan 19 17:56:20 CET 2001 hannes:
* mod, div for intvec fixed
* highcorner for global case fixed
* highcorner for qring fixed
Tue Feb  1 09:33:35 MET 2000 hannes: summary of changes
* lift changed: - uses interanlly a different algorithm 
                  (for SB and NON-SB unified)
                - can be used with an optional 3rd argument (a matrix name),
                  if given, the "matrix of units" will be stored in it
* new command: division (extension of lift)
     division(M,SM) returns a list (T,U,R) with SM*U+R=M*T
* new monomial ordering (internal change only): 
   use of inline function instead of a function pointer
   (possible point for difficulties: mcompSchrB(polys.cc), pSetSchreyerOrdM
   (polys.cc))
* new Library: 
   spectrum.lib: interface to Stefan Endrass' spectrum routines
   (Stefan Endrass/H.Schoenemann)
   (still incomplete, requires a "special" Singular)
* new Library: 
   CaMuReg.lib: PROCEDURES FOR COMPUTING CASTELNUOVO-MUMFORD REGULARITY
   Authors:I.Bermejo/Ph.Gimenez/G.-M.Greuel
   (not included in the documemtation, not included in the tests)
* new command: hres 
    - computes a free resolution of an ideal using Hilbert-driven algorithm
* new commands: convhull, simplex (M.Wenk)
  (not documented, not included in the documemtation, not included in the tests)
  
Fri Aug 13 13:20:01 MET DST 1999 hannes
* made fe_fgets_stdin an function pointer instead of a macro
  ( febase.cc febase.h feread.cc misc.cc sing_mp.cc tesths.cc)

Thu Aug 12 12:57:49 MET DST 1999 hannes
* integrated "spectrum" by Stefan Endrass, inactive by default
  (Makefile.in claptmpl.cc feResource.cc iparith.cc mod2.h.in
  tok.h GMPrat.h GMPrat.cc kmatrix.h multicnt.h multicnt.cc 
  npolygon.h npolygon.cc semic.h semic.cc spectrum.h spectrum.cc
  splist.h splist.cc)

Thu Apr 15 19:26:07 MET DST 1999 hannes
  * start to implement debugger (sdb.h,sdb.cc, febase*, iplib,cc, scanner)

Tue Mar 16 15:54:02 MET 1999 hannes
  * introduced new routine ERROR(string) (iparith.cc, tok.h)
  * added trace flag for proc (ipid.cc iplib.cc, febase*)

Mon Mar  8 18:27:26 MET 1999 hannes
  * access to coeff-description via functions (1. approach)
    (rChar,  rInternalChar, rField_is_Zp, rField_is_Q,
     rField_is_R, rField_is_GF, rField_is_Zp_a, rField_is_Q_a,
     rField_has_simple_inverse)

Wed Dec 16 16:02:07 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * clapsing.cc: debugging output modified

Thu Oct 22 14:21:17 MEST 1998 <krueger@mathematik.uni-kl.de>
        * tesths.cc,subexpr.h,subexpr.cc,ipshell.h,ipshell.cc,iplib.cc
        * ipid.h,ipid.cc,ipassign.cc,iparith.cc
          - Added assignment <package>=<package> via ref-counter
            rewriten killhdl for packages
          - Added libname,language to packages
          - exportto(Up,...) 'Up' defined in syMake
          - listvar() shows toplevel-packages too.

Mon Oct 19 16:01:18 MESZ 1998 hannes
* hannes: limitations on length of arguments removed (was 200 chars)
  (iplib.cc)

Thu Oct 15 15:54:05 MEST 1998 <krueger@mathematik.uni-kl.de>
        * extra.cc,grammar.y,ipid.cc,ipid.h,iplib.cc,ipshell.cc
        * ipshell.h,ring.cc,structs.h,tesths.cc,mod2.h.in
          Replaced ring *iiLocalRing[] by a stack (class namerec)
          To use old method define USE_IILOCALRING in mod2.h
          Old method incompatible with HAVE_NAMESPACES!

1998-10-14  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * sing_mp.cc (slOpenMPLaunch): added slKill as link function
        * added --MPrsh to slOpenLaunch

Wed Jul  1 15:25:23 MET DST 1998 hannes:
* fixed bug with quotient: M:module(0) returns (1), not ([1])

Tue Jun 30 18:30:02 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * claptmp.cc (tmax, tmin(Var, Var)): instantiations added

Fri Jun 19 10:01:59 MET DST 1998 hannes
* hannes: changed back: quot is now from standard.lib,
                        quotient the C-version
                        (iparith.cc LIB/standard.lib)

Thu Jun 18 19:27:27 MET DST 1998 hannes
        * error handling (grammar.y iparith.cc iplib.cc)
          (leaving of levels, local vars, messages,..)
          The reason:
               proc p { intvec w; w[0]; }
               proc p2 {int i;p();"huhu";}
               p2(); int i; listvar();

1998-06-13  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * feread.cc: explicit declaration of stuff we need from readline.h

1998-06-12  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * polys.cc: pComp for simple orderings based on only three
        routines (no variation for # of variables)

        * spolys0.cc (spGSpolyLoop): globally replaced by spSpolyLoop_General

Fri Jun 12 12:11:06 MET DST 1998 hannes
        * minor optimizations in polys.cc, kutil.* kstd1.cc:
          pass pointers, not structures to posIn[LT],
          do not check for NULL in pDeg (as pFDeg does not check)

Wed Jun  3 16:20:22 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * Makefile.in (DOCS): target removed
          (DISTFILES): reference to `$(DOC)' removed
          (distclean): reference to `$(docdir)' removed

Wed Jun 03 16:46:06 1998    <pohl@FUECHSE>

        * claptmpl.cc: instantiation for operator == (CFFactor, CFFactor)
          added

Tue Jun  2 17:28:48 MET DST 1998 hannes
        * introduced /* */ comments
        * some code cleanups
Fri May 29 17:00:27 MET DST 1998 hannes
        * change res to nres (cmd), resu to res(standard.lib)
          including changes to libs, docs (partially)
Wed May 27 19:13:10 MET DST 1998 hannes
        * removed #define HAVE_GMP and non-gmp-parts
Wed May 20 15:03:28 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * LIB/primdec.lib (info): info string reformated

1998-05-19  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * find_exec.c (find_executable): add "." top path, if under WINNT
        and MSDOS display

        * mmutil.c (mmCheckDBMCB): use _end only #ifdef unix

        * ideals.cc (idDelLmEquals): added idDelLmEqual == simplify(16),
        and idDelDiv == simplify(32); improved pComparePolys

1998-05-18  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * extra.cc (jjSYSTEM): changed "whoami" --> "Singular", added
        "nblocks"

Sat May 16 14:14:20 MET DST 1998 hannes
* avoid multiple objects of the same name (fix keepring)
Fri May 15 18:02:57 MET DST 1998 hannes
* added type conversion: ideal(map) -> map
Fri May 15 13:06:32 MET DST 1998 hannes
* added syntax: kill (....)
Thu May 14 16:40:43 MET DST 1998 hannes
* fixed bug in CoeffOfKBase (ideals.cc)
Thu May 14 12:01:53 MET DST 1998 hannes
* a ring with a coeff. field GF(p,n) cannot be constructed
  without gftables (ring.cc)
Wed May 13 16:52:09 MET DST 1998 hannes
        * changed syntax of NOT (does not require () any more)
Tue May 12 16:58:13 MET DST 1998 hannes
        * changed return type of option(): none -> string
Tue May 12 11:57:50 MET DST 1998 hannes
        * added "lres"
1998-05-08  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * extra.cc (jjSYSTEM): put all undocumented system calls into
        #ifdef HAVE_EXTENDED_SYSTEM which is _not_ defined by default

        * exteded system("random") to always return the seed of the random
        generator

Thu May  7 19:49:34 MET DST 1998 hannes
        * added syntax rule "proc <name> <arglist> <string> <body>"
        * speedup for feReadLine

Wed May  6 19:10:59 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * find_exec.c (find_executable): bug fix.  Recognizes
          `../Singular' properly.

Tue May  5 14:06:12 1998  Jens/Kai

        * libparse.l: message fix

Thu Apr 30 19:16:45 MET DST 1998 hannes
        * fixed "missing e-o-buffer" for long lines in febase.inc

Wed Apr 29 18:26:19 MET DST 1998 hannes
        * added filed list_length tossyStrategy
        ( for conversion list <-> resolution): syz.h, syz1.cc, iparith.cc
1998-04-29  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mmutil.c (mmGetIndex): new implementation: Use generated lookup
        table (mmutil.inc) instead of "binary" search on size

Tue Apr 28 19:56:46 MET DST 1998 hannes
  * ipassign.cc: fixed assignment of resolution to list: need ipMoveId
1998-04-28  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * kstd2.cc (redHomog): Some more ouput for KDEBUG && TEST_OPT_DEBUG

        * mminit.cc: introduced memory(2) which measures physical memory
        consumption using the system call sbrk (this never lies!)

Mon Apr 27 18:07:21 MET DST 1998 hannes
        * use ReAlloc for enlargeT, enlargeL  (kutil.cc)
Mon Apr 27 16:45:41 MET DST 1998 hannes
        * fixed conversion of factory 0 to poly NULL (clapconv.cc)

1998-04-27  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * febase.cc (myfread): introduced myfread and myfopen which assure
        that newlines in text files are always \n

Fri Apr 24 19:14:42 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * clapsing.cc (FACTORY_GCD_STAT, singclap_divide_content):
          dependency on FACTORY_GCD_TEST removed.  Statistics are now done
           using `FACTORY_GCDSTAT' and `FCATORY_CONTSTAT' which are defined
           to expand to nothing if `FACTORY_GCD_TIMING' is off.

        * extra.cc (FACTORY_GCD_STAT): dependency on `FACTORY_GCD_TEST'
          removed.  Includes `gcd_stat.h' in dependency on
          `FACTORY_CGD_STAT'.

        * extra.cc (jjSYSTEM): new command `gcdstat' in dependency on
          `FACTORY_GCD_STAT'

Fri Apr 24 18:25:23 MET DST 1998 hannes
  * fixed bug in maps.cc: size of monom is not pMonomSize but mmGetSpecSize()
  * changed header in tesths.cc
  * changed handling of ring changes (polys*.cc ring.cc)
Thu Apr 23 20:53:06 MET DST 1998 hannes
  * removed END_GRAMMAR ("RETURN") from iparith.cc, grammar.y
Thu Apr 23 20:16:24 MET DST 1998 hannes
  * fixed bug in rKill of Q-rings (ring.cc, polys.cc)

Thu Apr 23 11:12:48 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * clapsing.cc (FACTORY_CFTROUT, FACTORY_CFAOUT): stuipd bug fix

        * clapsing.cc (FACTORY_ALGOUT, FACTORY_CFTROUT, FACTORY_CFAOUT):
          new macros for debugging data transfer to Factory
           (singclap_divide_content, singclap_alglcm,
           singclap_algdividecontent): use the new macros

        * clapsing.cc (FACTORY_GCD_TIMING, singclap_divide_content,
          singclap_alglcm, singclap_algdividecontent): dependency on
          FACTORY_GCD_TEST removed.  Timings are now done directly using
          `TIMING_START' and `TIMING_END' which are defined to expand to
          nothing if `FACTORY_GCD_TIMING' is off.

        * extra.cc (FACTORY_GCD_TIMING): dependency on FACTORY_GCD_TEST
          removed

        * longalg.cc (naNormalize): gcd calculation depends on #define
          `FACTORY_GCD_TEST'

Wed Apr 22 09:42:35 MET DST 1998 hannes
  * several changes concerning stdfac
    (kstdfac.cc, kutil.cc kutil.h)

Tue Apr 21 15:19:10 MET DST 1998 hannes/jens
  * gdc in Q(a) returns "not implemented" (clapsing.cc)

Tue Apr 21 12:30:44 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * clapsing.cc  (singclap_gcd): checks for `NULL' removed

        * clapsing.cc, extra.cc (FACTORY_GCD_TEST, FACTORY_GCD_STAT,
           FACTORY_GCD_DEBOUT, FACTORY_GCD_TIMING): new #defines for gcd
          testing
        * clapsing.cc (singclap_divide_content, singclap_alglcm,
          singclap_algdividecontent): code added for factory testing.
            Wrapped by #defines `FACTORY_GCD_TEST', `FACTORY_GCD_STAT',
           `FACTORY_GCD_DEBOUT', and `FACTORY_GCD_TIMING'.
        * extra.cc (jjSYSTEM): code added for factory testing.  Wrapped
          by #defines `FACTORY_GCD_TEST' and `FACTORY_GCD_TIMING'.

Fri Apr 17 09:53:53 MET DST 1998 hannes
 * fixed a minor but very nasty bug: nlSetMap was resetting npPrimeM
    (longrat.cc)

1998-04-21  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mmprivat.h: Got rid off mmheap.cc, "inlined" mmPutMemory

        * longalg.h:  Exponents in parameter (polys) are typedef'ed to
        EXPONENT_TYPE

1998-04-20  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mmallocb.c: Merged with mmheap.c.

1998-04-16  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mpsr_PutPoly.cc: Took out normalization of rational numbers
        before they are put -- might have side effects

        * extra.cc: added system("--option") which returns value of
        option; in debug mode: system("OptionValues") lists all option
        values

        * sing_mp.cc: use long option names for MP link options
        * MPtcp:launch: Uses find_exec as default application

        *  tesths.cc: New (handling of) command line options (long
        options, usage of getopt_long): Parse more than one argument
        script, etc ..
        *  added getopt.[c,h]for parsing of command lines

        * mod2.h.in, configure.in: Got rid off str* tests

1998-04-07  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mpsr_Put.cc (mpsr_PutDump): dump does not dump LIB string any more

        * extra.cc (jjSYSTEM): added System("whoami") to return full
        executable pathname of running Singular

Tue Apr  7 10:27:50 MET DST 1998 hannes
        * fixed scanner bug: ignoring { and } in <block> (scanner.l)

1998-04-06  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * spSpolyLoop.h: neww calling interface for spGetSpolyLoop

        * kstd1.cc (kNF): moved strat->ak field initailization out of
        initBuchMora into single routines

        * febase.cc (feGetSearchPath): added feGetSearchPath; changed
        algorithm for searching files: $SINGULARPATH -> relative to
        executable -> burnt-in locations
        * added find_exec.c to get absolute pathname of executable

Mon Apr  6 14:23:52 1998  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * claptmpl.cc: instantiation for `tabs()' added

Sat Apr  4 00:52:58 MET DST 1998 Kai Krueger <krueger@mathematik.uni-kl.de>
        * iplib.cc libparse.cc libparse.h libparse.l misc.cc LIB/*.lib
          Changed help for libraries.

Wed Apr  1 20:55:15 MET DST 1998 hannes
        * mpsr_Tok.cc,tok.h: minor fix, removed VERBOSE_CMD
        * iparith.cc ipconv.cc: added conversion list <-> resolution
        * lists.cc, syz1.cc : fixed bug in conversion (list<->res.):
          handling "empty" case
        * scanner.l: added option: %option always-interactive

Tue Mar 31 10:47:06 MET DST 1998 hannes
        * feread.cc: fixed handling of empty history
        * clapsing.cc: fixed gcd(0,..) and gcd(..,0) -> pOne()
        * febase.h/febase.inc: renaming of scanner variables
          ( yy_blocklineno, yy_noeof)
        * febase.inc: increased speed in feReadLine
        * minor changes in scanner/grammar/iparith.cc (example)

1998-03-27  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * longalg.cc (naDBTest): fixed lines for number tests

        * added spSpolyLoop.inc to repository

        * algmap.cc (maAlgpolyMap): fixed bug which changed preimage

1998-03-23  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * taged version 1.1.7 -- unconditional fast version

        * polys-impl.cc, polys.cc: No COMP_FAST any more

        * Makefile.in: Introduced variable PERL, set by configure

        * kstdfac.cc (kStratCopy): kModW iv is not copied, but just the
        pointer is set

1998-03-18  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * Makefile.in: added Singularb target for bprof

        * polys-impl.h, polys-comp.h: Cleaned up COMP_FAST and related
        #defines

1998-03-16  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * polys-impl.h: no #define COMP_FAST

        * configure.in,Makefile.in: check for flex -P; increased version
        number to 1.1.7

Fri Mar 13 16:16:27 MET 1998 hannes
  * fixed: Singular crashed while changing the minpoly in GF(q)
    (ipassign.cc)

Fri Mar  6 13:27:45 MET 1998 Kai Krueger <krueger@mathematik.uni-kl.de>
        * new: libparse.l,libparse.cc,utils.cc,ytils.h
          scanner for a quick check of singular-libraries.
        * Makefile.in,mod2.h.in,iplib.cc,structs.h,subexpr.h
          use a scanner when loading libraries.
        * grammar.y,ipassign.cc,subexpr.h
          procinfo: added position of end of proc-definition
                    added flag for 'static'-proc (proc that can only be used
                          in the library they are defined).
        * LIB: deform.lib,finvar.lib,hnoether.lib,normal.lib,presolve.lib
               primdec.lib,tex.lib
          made fixes requested by libparse (s.a. brackets, ....)

1998-03-04  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * febase.h: added macro assume()

        * spSpolyLoop.cc: Automatic generation of SpolyLoops using
        spSpolyLoop.pl

        * kstd*.cc: New calling interface to get SpolyLoop

        * ring.h: Introduced rOrderType_t

Mon Mar  2 16:18:25 MET 1998 hannes
   * changed handling of "echo" in examples: do not report file + lineno
     (febase.inc,lib0lib.res, inoutlib.res, mem.res, homlib.res)

Fri Feb 27 15:02:10 MET 1998 hannes
   * new input scheme: many modifications to febase.h, febase.inc,
     febase.cc, scanner.l, grammar.y, iplib.cc

Tue Feb 17 18:43:11 MET 1998 hannes
        * added additional factorization check after redTail
          (kstdfac.cc)

1998-02-17  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * longalg.cc (napWrite): made it globally available to support
        FACTORY_DEBUG_OUT

        * clapsing.cc (singclap_algdividecontent): inserted
        FACTORY_DEBUG_OUT

Mon Feb 16 10:43:38 MET 1998 hannes
   * added HAVE_TCL to ring.cc

Mon Feb  9 12:28:21 MET 1998 hannes
   * added tests for coeff-filed GF(q), added stbus for GF(q)-conversion
     (clapconv.cc clapsing.cc clapconv.h)

Tue Jan 27 19:45:19 MET 1998 hannes
   *  bug fixes for TEST_MAC_ORDER (binom.* polys-impl.h, spSpolyLoop.cc)
      (binom.* poly-impl.* spSpolyLoop.cc)

Mon Jan 26 18:40:43 MET 1998 hannes
   * changes in iparith.cc for define: PROC_BUG
     useful, if c++ cannot type cast proc variables

Sat Jan 24 18:21:24 MET 1998 hannes
   * bug fixes for TEST_MAC_ORDER (binom.* polys-impl.h, spSpolyLoop.cc)

Sat Jan 17 18:56:34 MET 1998 hannes
   * changes for TEST_MAC_ORDER, part 3 (binom.cc, binom.h, spSpolyLoop.cc)

Sat Jan 17 18:21:15 MET 1998 hannes
        * removed duplicate _memcpyW from mmalloc.c
        * fixed type cast in iplib.cc
        * changes for TEST_MAC_ORDER, part 2 (binom.cc, binom.h, spSpolyLoop.cc)

Fri Jan 16 15:30:07 MET 1998 Kai Krueger <krueger@mathematik.uni-kl.de>
        * extra.cc,febase.cc,febase.inc,grammar.y,iparith.cc
        * ipassign.cc,ipid.cc,ipid.h,iplib.cc,ipshell.h,misc.cc
        * mpsr_Put.cc,mpsr_Put.h,silink.cc,structs.h,subexpr.cc,subexpr.h
        * tesths.cc
          Implementation of new proc-scheme done.

Fri Jan 16 14:51:07 MET 1998 Kai Krueger <krueger@mathematik.uni-kl.de>
        * Makefile.in,tests/mpcheck,teste/comparecheck:
          fixed use of correct Singular during checks

Fri Jan 16 09:23:07 MET 1998
        * changes for TEST_MAC_ORDER, part 1 (hannes)

Wed Jan 14 15:36:04 1998  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * polys-impl.h (pMonAddFast): fixed handling of component

        * mmutil.c: added _memcpyW for DO_DEEP_PROFILE

        * binom.h: #undef TEST_MAC_ORDER as default

        * polys-impl.h: fixes to make things clearer and for
          NO_EXP_VECTOR_OPS

        * Makefile.in (Singularp): use static linking for

Fri Dec 19 17:22:26 1997  Jens Schmidt  <schmidt@mathematik.uni-kl.de>

        * claptmpl.cc: template instantiation for `Array<REvaluation>'
          added

        * fglmcomb.cc, fglmhom.cc, fglmzero.cc, claptmpl.cc: #include
          directives fixed (templates/list.h renamed to
           templates/ftmpl_list.h)

Thu Dec 18 15:23:29 MET 1997
        * hannes:
        - removed type "binary" and handling routines
        (iparith.cc ipid.cc subexpr.cc tok.h)
        - fixed m16ex (doc/examples.doc)
        - fixed reference (doc/singular.doc, doc/start.doc)

Wed Dec 17 09:47:58 MEZ 1997 Kai Krueger <krueger@mathematik.uni-kl.de>
        * test/dbm_test.[in/out]: rewrite of dbm-tests.

Tue Dec 16 16:59:41 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * polys-impl.h: Introduced COMP_NO_EXP_VECTOR_OPS -- which turns
        off "vector techniques" of monomial operations, i.e. does
        everything exponent-wise

Mon Dec 15 23:31:56 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * polys-impl.h: Various small bug - fixes and changes in
          preparation of COMP_FAST merge: hilbert series, maps are
          ok; sres and syz are still buggy; small things still need to be
          checked;

Fri Dec 12 15:38:19 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mmallocb.c (mmDBFreeBlock): introduced UNREG_MEM_PATTERN which,
          when defined, inserts unregular memory pattern in
          allocated/freed memory

        * all: changed dangerous pNew calls to pInit's

Fri Dec  5 18:43:47 MET 1997
        * hannes: fix to ideals.cc: avoid pGetExp(p,0)

Thu Dec  4 16:13:31 MEZ 1997 Kai Krueger <krueger@mathematik.uni-kl.de>
        * ndbm.cc: don't replace bcopy by memcpy if possible, otherwise
          the database (>1024 bytes) will be corrupted.
        - added check for bcopy() in configure.

Wed Dec  3 16:14:51 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * Many changes to prepare for implementation of fast comparison
                  schemes: Here are only a few:
        - added file polys-impl.h which implements low-level poly stuff
        - removed file polys2.cc, added polys-impl.cc
        - added Singularp target to Make
        - prepared configure for setting of exponent type
        - got rid of as many direct p->exp[..] accesses as possible
        - added file spSpolyLoop.cc spSpolyLoop.h polys-comp.h
        * polys-impl.h: if you defined COMP_FAST, then fast polynomial
                  comparsions are eanbled (still needs a lot of debugging)


Fri Oct 31 05:45:25 1997  Olaf Bachman  <bachman@bombelli.dm.unipi.it>

        * polys1.cc et al: got rid of p[Get/Set]ExpV routines, provided
                  pCopy2 instead

Wed Oct  8 12:22:47 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * increased version number to 1.1.3

        * ndbm.cc: Solaris compatibility: #define bcopy bzero, bcmp;
                  #include <fcntl.h>
        * configure.in: added check for fcntl.h sys/types.h sys/stat.h, ucblib
          ensured that either lgmp or lsmallgmp is in $LIBS

Tue Sep 16 15:45:44 MET DST 1997
        * hannes: changed/corrected/clean naNormalize, naLcm, pCleardenom, pContent
            (polys1.cc, longalg.cc)
            added singclap_alglcm (clapconv.cc, clapsing.cc)

Tue Sep  9 11:05:28 MET DST 1997
        * hannes: flex-staff is now in febase.inc
               changed tutorial (doc/examples.doc, version-no: doc/tutor.tex)

Fri Aug 15 11:44:13 MESZ 1997  Kai Krueger <krueger@mathematik.uni-kl.de>
        * ndbm.cc: fix open-bug  for dos
          default mode of open is ascii, we need binary mode.

Thu Aug 14 18:04:04 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>
        and anne

        * Makefile.in, mod2.h.in, configure.in: cleaned up for dos
          cross-compilation

Tue Aug 12 19:08:20 MET DST 1997
        * hannes: added nExactDiv to numbers
        * hannes: corrected open bug in sing_dbm.cc (could only "r")
                  simplified sing_dbm.cc (many tests already in silink.cc)
                  added "mod" (as an alias to "%")
                  updated singular.doc: div/mod
                                        DBM: links
        * hannes: ANSI-conversion in ndbm.cc
          (added return types, include files)

Fri Aug  8 14:54:28 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * Makefile.in ndbm.[cc,h]: Together with krueger: Added files
          ndbm.[cc,h]; no longer linking with libdbm, instead,
          user supplied files; added dbm_test; small changes to sing_dbm.cc

Fri Aug  8 12:56:44 MET DST 1997
        * hannes: introduced "div" for integer division
          grammar.*, iparith.cc, singular.doc
        * changed version to 1.1.2/August

Thu Aug  7 14:51:59 1997  Olaf Bachmann  <obachman@mathematik.uni-kl.de>

        * mpsr_Get.cc (GetCopCommandLeftv): made +/* to binary ops

        * longrat.[h,cc]: added number   nlInit(number i) to initialize a
                  number, i.e. get it into the right Singular state

Wed Jul 16 12:57:22 MET DST 1997: hannes
        * introduced '.singularrc', modified loading of satndard.lib
          (tesths.cc)
Tue Jul 15 13:57:46 MET DST 1997: hannes
        * added call to proc in from standard.lib in tesths.cc

Wed Jul  9 17:50:23 MET DST 1997: hannes/siebert
        * added new type (resolution)
        -> extra.cc, ipid.cc, iparith.cc, ipconv.cc, syz.h, syz1.cc

Fri Jun 20 12:18:10 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * tesths.cc (main): fixed condition of mprs_ttGen execution

Thu Jun 19 10:49:10 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * mpsr_Put.h: corrected efinitions of MP_AnnotReqValTree, MP_AnnotReqValNode

Tue Jun 17 11:47:47 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Makefile.in (Singular): added mod2.h to dependencies of iparith.inc

        * tok.h: no discrimination of mac for inline definition any more

Wed Jun 11 09:56:05 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * mpsr_Tok.cc (cmd_dictcops): changed names of some MP_Cops

        * longrat.[cc,h], tesths.cc, Makefile.in, configure.in:
          added support for smallgmp

Tue Jun 10 17:25:28 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * sing_mp.cc: Got rid off warnings, when incomplete link specs

Thu Jun  5 15:16:19 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * tests/mpcheck: added check for correct remote shell

Sun May 25 14:06:12 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * configure.in: Fixed handling of CXXFLAGS -- it is not touched if
          set as env var

Fri May 23 11:40:14 1997  Olaf Bachmann  <obachman@schlupp.mathematik.uni-kl.de (Olaf Bachmann)>

        * Makefile.in: Changed dist target to cp; make distclean

Wed May 21 08:56:19 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * mpsr_Tok.cc: fixed dependencies/generation of mpsr_Tok.inc

        * tesths.cc (main): made -v option gmp v1.3 clean

Tue May 20 14:02:42 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * misc.cc: Put #include <factory.h> into #ifdef HAVE_FACTORY brackets

* hannes: ipshell.cc: fixed a bug in iiExport (multiple exports in rings)
          subexpr.cc: implemented sleftv::Copy for ring/qring
          syz1.cc: added missing idSkipZeros to LaScala*

Wed May 14 16:40:19 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Makefile.in: changed mpcheck.data so that the brain-dead sed on
          the suns does not mess up the output on files with long lines

Tue May 13 11:32:41 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * claptmpl.cc: changed template initializiation of libfac, so that
          class.cc and tmpl_inst.h does not need to be included

Mon May 12 16:48:14 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * misc.cc: Added / to Help_File and Info_File

Tue May  6 08:29:57 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * added factorycheck target in Makefile.in

        * Makefile.in (configure): took out rules which automatically
          reruns autoconf. Print out warning, instead

        * misc.cc, configure.in, mod2.h.in:
            added SINGULAR_INFODIR to search for info files

        * configure.in: Added AC_SUBST(WITH_LIBFAC, WITH_MP, WITH_FACTORY)

Mon May  5 10:31:15 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * #include "factory" instead of include "singfactory"

        * mod2.h.in: define buildin_gmp, if HAVE_GMP and macintosh

Sun May  4 11:14:44 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Added make target mpcheck; Update INSTALL file

        * mpsr_PutPoly.cc (PutRationalNumber): Normalize if number->s == 0
          and not if number->s == 2

        * mpsr_GetPoly.cc (GetGaloisNumber): Introduced special routines,
          since npInit op in GetModuloNumber messed things up

Sat May  3 00:07:55 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Makefile.in (CPPFLAGS): put -I. before other CPPFLAGS

        * febase.cc (feFopen): fixed bug in opening library from
          SINGULAR_DATADIR: SINGULAR_DATADIR is appended to
          getenv("SINGULARPATH")

        * small mpsr Changes to reflect some name changes of MP Dicts

        * configure.in Makefile.in: new scheme for updating Makefile mod2.h
          based on time-stamps

Fri May  2 17:29:32 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * mpsr.h: reflected changes of MP version 1.1.2 (Dicts in MP.h)

        * Fixed small bug in configure.in

Mon Apr 28 21:00:07 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Added README, INSTALL, COPYING file to distribution

        * tesths.cc (main): slightly changed Singular banner; fixed
          display of version number

Fri Apr 25 16:59:31 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * fixed configure.in s.t. sprintf test is correct

        * Changed SingularPath to SINGULARPATH

        * fixed sys/times.h and sys/time.h confusion

        * Various changes to reflect new configure (versions defined in
          configure.in, changed HAVE_LIBFACTORY into HAVE_FACTORY, data
          dir is pasted from configure into mod2.h and used from there in
          feFopen.

        * Added configure facility, repalced mod2.h by mod2.h.in Makefile
          by Makefile.in

Fri Apr 18 09:47:22 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * silink.cc (DumpAsciiIdhdl): LIB string is dumped without type
          declaration

        * mpsr_Get.cc (InitIdentifierLeftv): used mpsr_SetCurrRing(r,
          TRUE) so that pOne works if no ring did previously exist.

        * iparith.cc: Added jjPROC3.

Tue Apr 15 12:07:17 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * silink.cc (slStandardInit): changed Ascii type specifyer from
          "ascii" to "Ascii" for consistency

        * iparith.cc : added #else branch to #ifdef HAVE_FGLM in proc table

        *  (extra.cc): system("sh",command) returns exit status of command

Thu Apr 10 11:59:41 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * remote quit is now arranged using MP_CopMpQuit

        * Updated mpsr_* files for new naming convention of MP v:1.1.2

Tue Apr  8 10:43:48 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Reimplemented link structures. Cleaned it up. Introduced assignment
link = link. Fixed some bugs in asciidump. Made proc's work for MP links.

Sat Mar 29 16:01:39 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * silink.cc (DumpQring): Takes care of dumping a Qring
        (slInit): enable ascii link specification of the form "filename
        mode:w"

Fri Mar 28 14:12:05 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * Added routines dump(link) and getdump(link) for ascii and MP
          links

        * ipconv.cc (dConvertTypes): added int->module conversion so that
          'module m = 0' works

        * iparith.cc (jjVAR1): added LINK_CMD to list of typeof(...)

Thu Mar 27 21:20:20 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * added real time timer (rtimer) analog to timer

        * added command-line option "-d ticks_per_second" and "-m
          min_displayed_time_in_sec" and chahnged timer accordingly

        * added some #ifdef HAVE_FGLM in fglm*.cc


Wed Mar 26 14:02:15 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * added reference counter to links, updated slKill, slCopy, slInit
        * various small bug fixes for Batch mode

Mon Mar 24 14:27:26 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * sing_mp.cc (slOpenWriteMPFile): Added append and write mode to
          open MP:file

Sun Mar 23 20:48:41 1997  Olaf Bachmann  <obachman@ratchwum.mathematik.uni-kl.de (Olaf Bachmann)>

        * mpsr_Get.cc (InitIdentifierLeftv): Fixed bug which did not do
          pSetm(p) after creating a poly out of a variable

Thu Mar 20 11:57:00 1997  Olaf Bachmann  <obachman@schlupp.mathematik.uni-kl.de (Olaf Bachmann)>

        * sing_mp.cc (slInitBatchLink): initialized silink such that
          l->argv[0] == "MP:connect" (otherwise, slInitMP failed)

Wed Mar 19 15:38:08 1997  Olaf Bachmann  <obachman@schlupp.mathematik.uni-kl.de (Olaf Bachmann)>

        * hannes fixed maFindPerm to reflect new names <->parameter scheme

        * sing_mp.cc (mpsr_IsMPLink): fixed it

        * Makefile (tags): added target tags

